//
//  snowyAppDelegate.m
//  snowy
//
//  Created by Christian Franz on 03/12/2012.
//  Copyright 2012 cf/x AG. All rights reserved.
//

#import "snowyAppDelegate.h"

@implementation snowyAppDelegate

@synthesize window;

- (void)applicationDidFinishLaunching:(NSNotification *)aNotification {
	// set up connection to master brick
	theConnection = [[TinkerIO alloc] initWithHost:"localhost" port:4223]; // init as manual (no plug&play)
	theLCD = [[TDsnowyLCD alloc] initWithUID:"bnS"];
	[theConnection connectTo:theLCD];
	
	// LCD is good to use. clear screen, turn on LCD Backlight
	[theLCD home];
	[theLCD setBacklight:TRUE];
	
	// every 0.5s we update the LCD with a new frame
	// now go to sleep, and call 'update' in 0.1 s
	[self performSelector:@selector(update) withObject:self afterDelay:0.5];

}

- (void) update {
	[theLCD drawFrame];
	
	// do this again in 0.5s
	[self performSelector:@selector(update) withObject:self afterDelay:0.5];

}

- (void) applicationWillTerminate:(NSNotification *) aNotification {
	// say bye!
	[theLCD setAutosync:TRUE];
	[theLCD home];
	[theLCD writeString:@"bye..."];
	
	// turn off LCD backlight
	[theLCD setBacklight:FALSE];
}

@end
