//
//  snowyLCD.m
//  snowy
//
//  Created by Christian Franz on 03/12/2012.
//  Copyright 2012 cf/x AG. All rights reserved.
//

#import "snowyLCD.h"


@implementation TDsnowyLCD

-(id) initWithUID: (const char *) uid {
	self = [super initWithUID:uid];
	if (self) {
		// init ivars
		
		frame = 0;
		maxFlakeYPos = 6; // they fall deeper than LCD 4 lines
		
		int i = 0;
		while (i<cMaxFlakes) {
			// set up x, y, and falling speed
			xPos[i] = rand() % maxX; // x pos between 0..LCD width
			yPos[i] = (rand() % maxFlakeYPos) * 1.0;
			downSpeed[i] = 0.3 + (rand() % 100) / 100.0 * 0.7 + 0.1;
			
			i = i + 1;
		}
		
		[self setAutosync:FALSE];
	}
	return (self);
}

- (void) drawFrame {

	// first, clear screen. HINT: make sure autoSync is OFF before you call
	[self home];

	// now draw welcome string
	[self moveToX:7 Y:1];
	[self writeString:@"merry"];
	[self moveToX:5 Y:2];
	[self writeString:@"cf/x-mas!"];
	
	// now draw all snow flakes and simultaneously update position for next
	int i = 0;
	while (i < cMaxFlakes) {
		if (yPos[i] < maxY) {
			[self moveToX:xPos[i] Y:yPos[i]];
			[self writeChar:'*'];
		}
		yPos[i] = yPos[i] + downSpeed[i];
		if (yPos[i] > maxFlakeYPos) {yPos[i] = downSpeed[i];}
		i = i + 1;
	}
	
	
	// now transfer all to LCD
	[self updateLCD];
	
}
@end
